package InternalStructure;

import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.util.Random;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import CommonClasses.CommunicationContainer;
import CommonClasses.CommunicationKind;
import CommonClasses.Move;
import CommonClasses.Player;
import CommonClasses.State;
import CommonInterfaces.InterfacePlayerProxy;
import InterfaceParts.PortPlayerProxy;
import InterfaceParts.PortPlayerProxyOutbox;


public class TTT_GUI extends JFrame implements InterfacePlayerProxy {

	private static final long serialVersionUID = 1L;
	
	private JPanel jContentPane = null;

	protected String playerId;
	
	protected enum PlayerStateValue{disconnected, connected, playing}
	
	protected PlayerStateValue playerState = PlayerStateValue.disconnected;
	
	protected PortPlayerProxy playerPort;
	
	protected boolean enabledAction = false;

	private JLabel vPosition11 = null, vPosition12 = null, vPosition13 = null,
			vPosition21 = null, vPosition22 = null, vPosition23 = null,
			vPosition31 = null, vPosition32 = null, vPosition33 = null,
			vMessage = null;

	protected JLabel mapVPosition[][] = new JLabel[3][3];

	private JMenuBar jMenuBar1 = null;

	private JMenu gameMenu = null;

	private JMenuItem jMenuItemConnect = null,
			jMenuItemDisconnect = null,
			jMenuItemStart = null,
			jMenuItemPlayers = null,
			jMenuItemGiveUp = null,
			jMenuItemMessage = null;
	
	// ****************************************************
	// GUI specific operations
	// ****************************************************
	
	public TTT_GUI() throws HeadlessException {
		super();
		initialize();
	}

	public TTT_GUI(GraphicsConfiguration arg0) {
		super(arg0);
		initialize();
	}

	public TTT_GUI(String arg0) throws HeadlessException {
		super(arg0);
		initialize();
	}

	public TTT_GUI(String arg0, GraphicsConfiguration arg1) {
		super(arg0, arg1);
		initialize();
	}

	private void initialize() {
//		atorRede = new AtorRede(this);
		this.setSize(260, 330);
		this.setContentPane(getJContentPane());
		this.setTitle("TicTacToe");
//		tab = new Tabuleiro();
//		tab.iniciar();
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {

			Icon vazia = new ImageIcon(ClassLoader.getSystemResource("vazia.gif"));

			vMessage = new JLabel();
			vMessage.setBounds(new Rectangle(25, 10, 200, 20));
			vMessage.setText("On-Line Tic Tac Toe");

			vPosition11 = new JLabel();
			vPosition11.setBounds(new Rectangle(20, 40, 70, 70));
			vPosition11.setIcon(vazia);
			vPosition11.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(1, 1);
				}
			});
			vPosition12 = new JLabel();
			vPosition12.setBounds(new Rectangle(90, 40, 70, 70));
			vPosition12.setIcon(vazia);
			vPosition12.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(1, 2);
				}
			});
			vPosition13 = new JLabel();
			vPosition13.setIcon(vazia);
			vPosition13.setBounds(new Rectangle(160, 40, 70, 70));
			vPosition13.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(1, 3);
				}
			});
			vPosition21 = new JLabel();
			vPosition21.setBounds(new Rectangle(20, 110, 70, 70));
			vPosition21.setIcon(vazia);
			vPosition21.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(2, 1);
				}
			});
			vPosition22 = new JLabel();
			vPosition22.setBounds(new Rectangle(90, 110, 70, 70));
			vPosition22.setIcon(vazia);
			vPosition22.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(2, 2);
				}
			});
			vPosition23 = new JLabel();
			vPosition23.setBounds(new Rectangle(160, 110, 70, 70));
			vPosition23.setIcon(vazia);
			vPosition23.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(2, 3);
				}
			});
			vPosition31 = new JLabel();
			vPosition31.setBounds(new Rectangle(20, 180, 70, 70));
			vPosition31.setIcon(vazia);
			vPosition31.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(3, 1); 
				}
			});
			vPosition32 = new JLabel();
			vPosition32.setBounds(new Rectangle(90, 180, 70, 70));
			vPosition32.setIcon(vazia);
			vPosition32.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(3, 2);
				}
			});
			vPosition33 = new JLabel();
			vPosition33.setBounds(new Rectangle(160, 180, 70, 70));
			vPosition33.setIcon(vazia);
			vPosition33.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					click(3, 3);
				}
			});
			
			jMenuBar1 = new JMenuBar();
			jMenuBar1.add(getGameMenu());
			this.setJMenuBar(jMenuBar1);

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(vPosition11, null);
			jContentPane.add(vPosition12, null);
			jContentPane.add(vPosition13, null);
			jContentPane.add(vPosition21, null);
			jContentPane.add(vPosition22, null);
			jContentPane.add(vPosition23, null);
			jContentPane.add(vPosition31, null);
			jContentPane.add(vPosition32, null);
			jContentPane.add(vPosition33, null);

			mapVPosition[0][0] = vPosition11;
			mapVPosition[0][1] = vPosition12;
			mapVPosition[0][2] = vPosition13;
			mapVPosition[1][0] = vPosition21;
			mapVPosition[1][1] = vPosition22;
			mapVPosition[1][2] = vPosition23;
			mapVPosition[2][0] = vPosition31;
			mapVPosition[2][1] = vPosition32;
			mapVPosition[2][2] = vPosition33;

			jContentPane.add(vMessage, null);
		}
		return jContentPane;
	}
	
	private JMenu getGameMenu() {
		if (gameMenu == null) {
			gameMenu = new JMenu();
			gameMenu.setText("Actions");
			gameMenu.setBounds(new Rectangle(1, 0, 57, 21));
			gameMenu.add(getJMenuItemConnect());
			gameMenu.add(getJMenuItemDisconnect());
			gameMenu.add(getJMenuItemStart());
			gameMenu.add(getJMenuItemPlayers());
			gameMenu.add(getJMenuItemGiveUp());
			gameMenu.add(getJMenuItemMessage());
		}
		return gameMenu;
	}

	private JMenuItem getJMenuItemConnect() {
		if (jMenuItemConnect == null) {
			jMenuItemConnect = new JMenuItem();
			jMenuItemConnect.setText("Connect to the server");
			jMenuItemConnect
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							connect();
						}
					});
		}
		return jMenuItemConnect;
	}

	private JMenuItem getJMenuItemDisconnect() {
		if (jMenuItemDisconnect == null) {
			jMenuItemDisconnect = new JMenuItem();
			jMenuItemDisconnect.setText("Disconnect from the server");
			jMenuItemDisconnect
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							disconnect();
						}
					});
		}
		return jMenuItemDisconnect;
	}
	
	private JMenuItem getJMenuItemStart() {
		if (jMenuItemStart == null) {
			jMenuItemStart = new JMenuItem();
			jMenuItemStart.setText("Start game");
			jMenuItemStart
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							start();
						}
					});
		}
		return jMenuItemStart;
	}

	private JMenuItem getJMenuItemPlayers() {
		if (jMenuItemPlayers == null) {
			jMenuItemPlayers = new JMenuItem();
			jMenuItemPlayers.setText("Get the connected players");
			jMenuItemPlayers
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							getConnectedPlayers();
						}
					});
		}
		return jMenuItemPlayers;
	}

	private JMenuItem getJMenuItemGiveUp() {
		if (jMenuItemGiveUp == null) {
			jMenuItemGiveUp = new JMenuItem();
			jMenuItemGiveUp.setText("Give up");
			jMenuItemGiveUp
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							giveUp();
						}
					});
		}
		return jMenuItemGiveUp;
	}

	private JMenuItem getJMenuItemMessage() {
		if (jMenuItemMessage == null) {
			jMenuItemMessage = new JMenuItem();
			jMenuItemMessage.setText("Send message to opponent");
			jMenuItemMessage
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							sendMessage();
						}
					});
		}
		return jMenuItemMessage;
	}


	// ****************************************************
	// Problem domain operations
	// ****************************************************
	
	public void setPortPlayer(PortPlayerProxy aPort) {
		playerPort = aPort; 
	}
	
	protected void connect() {
		if (playerState == PlayerStateValue.disconnected) {
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			playerId = this.getPlayerId();
			if (playerId.equals("")) {
				int randomInt = 0;
				Random randomGenerator = new Random();
				randomInt = randomGenerator.nextInt(100000);
				playerId = "player" + Integer.toString(randomInt);
			}			
			portOutbox.connect(playerId);
			try {
				Thread.sleep(5000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
				portOutbox.confirmConnection();
		} else {
			this.communicateMessage("You are already connected");
		}
	}

	protected void disconnect() {
		if (playerState != PlayerStateValue.disconnected) {
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			if (playerState == PlayerStateValue.playing) {
				portOutbox.giveUp(playerId);				
			}
			portOutbox.disconnect(playerId);
//			playerState = PlayerStateValue.disconnected;
//			this.communicateMessage("Player disconnected successfully");
		} else {
			this.communicateMessage("You are already disconnected");
		}
	}

	protected void start() {
//		communicateMessage("start");
		if (playerState == PlayerStateValue.connected) {
			Player startOptions = new Player();
			startOptions.setSymbol(this.getPlayerSymbol());
			boolean againstProgram = this.evaluateAgainstProgram();
			startOptions.setAutomatic(againstProgram);
			if (againstProgram) {
				startOptions.setName(playerId);
			} else {
				String opponentId = JOptionPane.showInputDialog(this, "What is the opponent name?");
				if (opponentId.equals("")) {
					startOptions.setName(playerId);
				} else {
					startOptions.setName(opponentId);
				}
			}
			boolean localPlayerStarts = this.evaluateLocalPlayerStarts();
			startOptions.setTurn(localPlayerStarts);
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			portOutbox.start(startOptions);
		} else {
			if (playerState == PlayerStateValue.disconnected)
				this.communicateMessage("You need to connect to start a game");
			if (playerState == PlayerStateValue.playing)
				this.communicateMessage("You need to finish the current game to start a new one");
		}
	}

	private boolean evaluateLocalPlayerStarts() {
		boolean starts = false;
		boolean noAnswer = true;
		int answer;
		while (noAnswer) {
			answer = JOptionPane.showConfirmDialog(this,
					"Do you want to start?");
			starts = answer == JOptionPane.YES_OPTION;
			noAnswer = answer == JOptionPane.CANCEL_OPTION;
		}
		;
		return starts;
	}

	protected void getConnectedPlayers() {
		if (playerState == PlayerStateValue.connected) {
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			portOutbox.getConnectedPlayers();
		} else {
			if (playerState == PlayerStateValue.disconnected)
				this.communicateMessage("You need to connect to see the connected players");
			if (playerState == PlayerStateValue.playing)
				this.communicateMessage("You cannot see the players with a game in progress");
		}
		
	}

	protected void giveUp() {
		if (playerState == PlayerStateValue.playing) {
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			portOutbox.giveUp(playerId);
		} else {
			this.communicateMessage("There is no game in progress");
		}
		
		
	}

	protected void sendMessage() {
		if (playerState == PlayerStateValue.playing) {
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			String message = JOptionPane.showInputDialog(this, "What is the message to your opponent?");
			portOutbox.sendMessage(message);
		} else {
			this.communicateMessage("There is no game in progress");
		}
	}
	
	public void communicateMessage(String message) {
		JOptionPane.showMessageDialog(this, message);
	}

	public String getPlayerId() {
		String idJogador;
		idJogador = JOptionPane.showInputDialog(this,
				("What is your name?"));
		return idJogador;
	}

	public int getPlayerSymbol() {
		boolean exSelected = SymbolDialog.getSymbolX("What is your symbol?");
		if (exSelected) return 1;
		return 2;
	}
	
	public boolean evaluateAgainstProgram() {
		boolean againstProgram = false;
		boolean noAnswer = true;
		int answer;
		while (noAnswer) {
			answer = JOptionPane.showConfirmDialog(this,
					"Do you want to play against the program?");
			againstProgram = answer == JOptionPane.YES_OPTION;
			noAnswer = answer == JOptionPane.CANCEL_OPTION;
		}
		;
		return againstProgram;
	}

	public void click(int line, int column) {	// make move
//		communicateMessage("sending message");
		if ((playerState == PlayerStateValue.playing) && (enabledAction == true)) {
			Move move = new Move();
			move.setValues(line, column);
			PortPlayerProxyOutbox portOutbox = (PortPlayerProxyOutbox) playerPort.getOutbox();
			portOutbox.makeMove(move);
		} else {
			if (playerState != PlayerStateValue.playing) {
				this.communicateMessage("There is no game in progress");
			} else {
				this.communicateMessage("You are not enabled to play");
			}
		}
	}

	public void updateState(State state) {
		int value = 0;
		Icon vazia = new ImageIcon(ClassLoader.getSystemResource("vazia.gif"));
		Icon xis = new ImageIcon(ClassLoader.getSystemResource("xis.gif"));
		Icon bola = new ImageIcon(ClassLoader.getSystemResource("bola.gif"));
		String stateMessage = state.getStateMessage();
		// STATE UPDATE
		if (playerState == PlayerStateValue.connected) {
			playerState = PlayerStateValue.playing;
			if (stateMessage.contains(playerId)) {
				enabledAction = true;
			} else {
				enabledAction = false;
			}
		}
		if ((playerState == PlayerStateValue.playing) &&
			((stateMessage.contains("gave up")) || (stateMessage.contains("Game ended")) || (stateMessage.contains("Winner:"))))	{
			playerState = PlayerStateValue.connected;
			enabledAction = false;
		} else {
			if (stateMessage.contains(playerId)) {
				enabledAction = true;
			} else {
				enabledAction = false;
			}
		}
		// INTERFACE UPDATE
		vMessage.setText(stateMessage);
		for (int linha = 1; linha < 4; linha++) {
			for (int coluna = 1; coluna < 4; coluna++) {				
				value = state.getValue(linha, coluna);
				switch (value) {
				case 0:
					mapVPosition[(linha - 1)][(coluna - 1)].setIcon(vazia);
					break;
				case 1:
					mapVPosition[(linha - 1)][(coluna - 1)].setIcon(xis);
					break;
				case 2:
					mapVPosition[(linha - 1)][(coluna - 1)].setIcon(bola);
				}
			}
		}
	}

	@Override
	public void communicate(CommunicationContainer arg0) {
		String content = arg0.getContent();
		CommunicationKind kind = arg0.getKind();
		String title = "";
		switch(kind) {
			case connectionNotification:
				title = "Connection notification: ";
				if (content.equals("Server not connected")) {
					playerState = PlayerStateValue.disconnected;
				}
				if (content.equals("Connected to TTT Server")) {
					playerState = PlayerStateValue.connected;
				}
				break;
			case disconnectionNotification:
				title = "Disconnection notification: ";
				playerState = PlayerStateValue.disconnected;
				break;
			case irregularMoveNotification:
				title = "Irregular move notification: ";
				break;
			case connectedPlayerNotification:
				title = "Connected players: ";
				break;
			default:
				break;
		}
		this.communicateMessage(title + content);
	}

	@Override
	public void receiveMessage(String arg0) {
		this.communicateMessage("Message of the opponent: " + arg0);
	}

}
