package InterfaceParts;

import CommonClasses.Move;
import CommonClasses.Player;
import CommonInterfaces.InterfaceProxyPlayer;
import InternalStructure.InternalServerProxy;
import cip.InterfacePort;

public class PortPlayer extends InterfacePort implements InterfaceProxyPlayer {
	
	protected InternalServerProxy internalReference;
	
	public PortPlayer(String string) {
		id = string;
	}
	
	public void setInternalReference(InternalServerProxy internalObject) {
		internalReference = internalObject;
	}
	
	@Override
	public void initialize() {
		outbox = new PortPlayerOutbox();
	}

	@Override
	public void confirmConnection() {
		internalReference.confirmConnection();
	}

	@Override
	public boolean connect(String arg0) {
		return internalReference.connect(arg0);
	}

	@Override
	public void disconnect(String arg0) {
		internalReference.disconnect(arg0);
	}

	@Override
	public void getConnectedPlayers() {
		internalReference.getConnectedPlayers();
	}

	@Override
	public void giveUp(String arg0) {
		internalReference.giveUp(arg0);
	}

	@Override
	public void makeMove(Move arg0) {
		internalReference.makeMove(arg0);
	}

	@Override
	public void sendMessage(String arg0) {
		internalReference.sendMessage(arg0);
	}

	@Override
	public void start(Player arg0) {
		internalReference.start(arg0);
	}

}
