package InterfaceParts;

import CommonInterfaces.InterfaceProxyServer;
import CommonInterfaces.Throw;
import InternalStructure.InternalPlayerProxy;
import br.ufsc.inf.leobr.cliente.Jogada;
import br.ufsc.inf.leobr.cliente.OuvidorProxy;
import cip.InterfacePort;

public class PortServer extends InterfacePort implements InterfaceProxyServer, OuvidorProxy {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected InternalPlayerProxy internalReference;
	protected boolean serverConnected = false;


	public PortServer(String string) {
		id = string;
	}
	
	public void setInternalReference (InternalPlayerProxy internalObject) {
		internalReference = internalObject;
		((PortServerOutbox) outbox).connectToNetgames(this);
	}

	@Override
	public void initialize() {
		outbox = new PortServerOutbox();
		((PortServerOutbox) outbox).initialize();
	}

	@Override
	public void receive(Throw arg0) {
		internalReference.receive(arg0);
	}

	@Override
	public void receiveMessage(String arg0) {
		internalReference.receiveMessage(arg0);
	}
	
	public void setConnected (boolean value) {
		serverConnected = value;
	}

	public boolean getConnected () {
		return serverConnected;
	}

	@Override
	public void start(int arg0) {
		this.setConnected(true);
	}


	@Override
	public void iniciarNovaPartida(Integer posicao) {
		this.start(posicao);
	}

	@Override
	public void receberMensagem(String msg) {
		this.receiveMessage(msg);
	}

	@Override
	public void receberJogada(Jogada jogada) {
		this.receive((Throw) jogada);
	}
	@Override
	public void finalizarPartidaComErro(String message) {
		// TODO Auto-generated method stub
	}

	@Override
	public void tratarConexaoPerdida() {
		// TODO Auto-generated method stub
	}

	@Override
	public void tratarPartidaNaoIniciada(String message) {
		// TODO Auto-generated method stub	
	}

}
