package InternalStructure;

import CommonClasses.State;
import CommonClasses.CommunicationContainer;
import CommonClasses.CommunicationKind;
import CommonInterfaces.InterfaceProxyServer;
import CommonInterfaces.Throw;
import InterfaceParts.PortPlayer;
import InterfaceParts.PortPlayerOutbox;
import InterfaceParts.PortServer;
import InterfaceParts.PortServerOutbox;

public class InternalPlayerProxy implements InterfaceProxyServer {
	
	protected PortServer portServer;
	protected PortPlayer portPlayer;
	
	public void setPortServer (PortServer aPortServer) {
		portServer = aPortServer;
	}
	
	public void setPortPlayer (PortPlayer aPortPlayer) {
		portPlayer = aPortPlayer;
	}
	
	@Override
	public void receive(Throw arg0) {
		PortPlayerOutbox playerOutbox = (PortPlayerOutbox) portPlayer.getOutbox();
		PortServerOutbox serverOutbox = (PortServerOutbox) portServer.getOutbox();
		if (arg0 instanceof State) {
			playerOutbox.updateState((State) arg0);
		} else {
			CommunicationKind kind = ((CommunicationContainer) arg0).getKind();
			if (kind == CommunicationKind.disconnectionNotification) {
				serverOutbox.disconnect();		//		disconnectNG()
			} 
			playerOutbox.communicate((CommunicationContainer) arg0);
		}
	}

	@Override
	public void receiveMessage(String arg0) {
		PortPlayerOutbox outbox = (PortPlayerOutbox) portPlayer.getOutbox();
		outbox.receiveMessage(arg0);
	}

	@Override
	public void start(int arg0) {
		// no action - the existence of this operation is a requirement of Netgames
	}


}
