package InterfaceParts;

import cip.InterfacePort;
import CommonClasses.Move;
import CommonClasses.State;
import CommonInterfaces.InterfaceAutomatic;
import InternalStructure.InternalPlayer;

public class PortOpponent extends InterfacePort implements InterfaceAutomatic {
	
	protected InternalPlayer internalReference;
	private TTTAutomaticPlayer componentRoot;
	
	public PortOpponent(String argId) {
		id = argId;
	}
	
	public void setInternalReference(InternalPlayer argPl) {
		internalReference = argPl;
	}
	
	public void setComponentRoot(TTTAutomaticPlayer root) {
		componentRoot = root;
	}
	
	@Override
	public void initialize() {	// empty	
	}

	@Override
	public Move automaticMove(State arg0) {
		Move playerMove;
		playerMove = internalReference.automaticMove(arg0);
		return playerMove;
	}

	@Override
	public void selfDestruct() {
		internalReference.selfDestruct();	
		internalReference = null;
		componentRoot.selfDestruct();
	}

}
