package InternalStructure;

import CommonClasses.State;
import CommonClasses.Move;

public abstract class Strategy {
 
	protected int moveOrder = 0;
	protected int strategyWay = 0;
	 
	public abstract Move getMove(State gameState);
	public abstract Move getMove1(State gameState);
	public abstract Move getMove2(State gameState);
	
	public Move getFirstMove() {
		Move myMove;
		myMove = new Move();
		myMove.setValues(1, 1);
		return myMove;
	}
	
	public Move getMove3(State gameState) {
		Move myMove;
		myMove = this.getBasicMove(gameState);
		return myMove;
	}
	 
	public Move getMove4(State gameState) {
		Move myMove;
		myMove = this.getBasicMove(gameState);
		return myMove;
	}
	 
	public Move getBasicMove(State gameState) {
		moveOrder++;
		Move myMove;
		myMove = this.getMoveToWin(gameState);
		if (myMove.getLine() == 0) {
			myMove = this.getMoveThatAvoidsDefeat(gameState);
			if (myMove.getLine() == 0) {
				myMove = this.getAnyPossibleMove(gameState);
			};
		};
		return myMove;
	}
	 	 
	
	public Move getMoveThatFillsLine (State gameState, int aSymbol){
		Move myMove;
		int symbolCounter = 0;
		int emptyLine = 0;
		int emptyColumn = 0;
		myMove = new Move();
		for (int aLine=1; aLine<4; aLine++){
			if (gameState.occupiedInLine(aLine) == 2) {
				symbolCounter = 0;
				emptyLine = 0;
				emptyColumn = 0;
				for (int aColumn=1; aColumn<4; aColumn++){
					if (gameState.informEmptyPosition(aLine, aColumn)) {
						emptyLine = aLine;
						emptyColumn = aColumn;
					} else {
						if (gameState.getValue(aLine, aColumn) == aSymbol) {
							symbolCounter++;
						}
					};
				};
				if (symbolCounter == 2 ) {
					myMove.setValues(emptyLine, emptyColumn);
					return myMove;
				};
			};
		};
		return myMove;
	}
	
	public Move getMoveThatFillsColumn (State gameState, int aSymbol){
		Move myMove;
		int symbolCounter = 0;
		int emptyLine = 0;
		int emptyColumn = 0;
		myMove = new Move();
		for (int aColumn=1; aColumn<4; aColumn++){
			if (gameState.occupiedInColumn(aColumn) == 2) {
				symbolCounter = 0;
				emptyLine = 0;
				emptyColumn = 0;
				for (int aLine=1; aLine<4; aLine++){
					if (gameState.informEmptyPosition(aLine, aColumn)) {
						emptyLine = aLine;
						emptyColumn = aColumn;
					} else {
						if (gameState.getValue(aLine, aColumn) == aSymbol) {
							symbolCounter++;
						}
					};
				};
				if (symbolCounter == 2 ) {
					myMove.setValues(emptyLine, emptyColumn);
					return myMove;
				};
			};
		};
		return myMove;
	}

	public Move getMoveThatFillsMainDiagonal(State gameState, int aSymbol){
		Move myMove;
		int symbolCounter = 0;
		int emptyLine = 0;
		int emptyColumn = 0;
		myMove = new Move();
		if (gameState.informEmptyPosition(1, 1)) {
			emptyLine = 1;
			emptyColumn = 1;
		} else {
			if (gameState.getValue(1, 1) == aSymbol) {
				symbolCounter++;
			}
		};
		if (gameState.informEmptyPosition(2, 2)) {
			emptyLine = 2;
			emptyColumn = 2;
		} else {
			if (gameState.getValue(2, 2) == aSymbol) {
				symbolCounter++;
			}
		};
		if (gameState.informEmptyPosition(3, 3)) {
			emptyLine = 3;
			emptyColumn = 3;
		} else {
			if (gameState.getValue(3, 3) == aSymbol) {
				symbolCounter++;
			}
		};
		if (symbolCounter == 2 ) {
			myMove.setValues(emptyLine, emptyColumn);
			return myMove;
		};
		return myMove;
	}

	public Move getMoveThatFillsSecondaryDiagonal (State gameState, int aSymbol){
		Move myMove;
		int symbolCounter = 0;
		int emptyLine = 0;
		int emptyColumn = 0;
		myMove = new Move();
		if (gameState.informEmptyPosition(3, 1)) {
			emptyLine = 3;
			emptyColumn = 1;
		} else {
			if (gameState.getValue(3, 1) == aSymbol) {
				symbolCounter++;
			}
		};
		if (gameState.informEmptyPosition(2, 2)) {
			emptyLine = 2;
			emptyColumn = 2;
		} else {
			if (gameState.getValue(2, 2) == aSymbol) {
				symbolCounter++;
			}
		};
		if (gameState.informEmptyPosition(1, 3)) {
			emptyLine = 1;
			emptyColumn = 3;
		} else {
			if (gameState.getValue(1, 3) == aSymbol) {
				symbolCounter++;
			}
		};
		if (symbolCounter == 2 ) {
			myMove.setValues(emptyLine, emptyColumn);
			return myMove;
		};
		return myMove;
	}
	
	public Move getMoveToWin(State gameState) {
		Move myMove, firstMove;
		int mySymbol;
		firstMove = this.getFirstMove();
		mySymbol = gameState.getValue((firstMove.getLine()), (firstMove.getColumn()));
		// varredura de linhas
		myMove = this.getMoveThatFillsLine(gameState, mySymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// varredura de colunas
		myMove = this.getMoveThatFillsColumn(gameState, mySymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// diagonal principal
		myMove = this.getMoveThatFillsMainDiagonal(gameState, mySymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// diagonal secundaria
		myMove = this.getMoveThatFillsSecondaryDiagonal(gameState, mySymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		return myMove;
	}
	 
	public Move getMoveThatAvoidsDefeat(State gameState) {
		Move myMove, firstMove;
		int mySymbol;
		int otherSymbol = 1;
		myMove = new Move();
		firstMove = this.getFirstMove();
		mySymbol = gameState.getValue((firstMove.getLine()), (firstMove.getColumn()));
		if (mySymbol == 1){
			otherSymbol = 2;
		};
		// varredura de linhas
		myMove = this.getMoveThatFillsLine(gameState, otherSymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// varredura de colunas
		myMove = this.getMoveThatFillsColumn(gameState, otherSymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// diagonal principal
		myMove = this.getMoveThatFillsMainDiagonal(gameState, otherSymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		// diagonal secundaria
		myMove = this.getMoveThatFillsSecondaryDiagonal(gameState, otherSymbol);
		if (myMove.getLine() != 0) {
			return myMove;
		};
		return myMove;
	}
	 
	public Move getAnyPossibleMove(State gameState) {
		Move myMove = null;
		for (int aLine=1; aLine<4; aLine++){
			for (int aColumn=1; aColumn<4; aColumn++){
				if (gameState.informEmptyPosition(aLine, aColumn)) {
					myMove = new Move();
					myMove.setValues(aLine, aColumn);
					return myMove;
				};
			};
		};
		return myMove;
	}
	 
}
