package InternalStructure;

import CommonClasses.State;
import CommonClasses.Move;

public class Strategy1 extends Strategy {
 
	public Move getMove(State gameState) {
		Move myMove;
		switch (moveOrder){
			case 0: myMove = this.getMove1(gameState);
			break;
			case 1: myMove = this.getMove2(gameState);
			break;
			case 2: myMove = this.getMove3(gameState);
			break;
			default: myMove = this.getBasicMove(gameState);		
		};
		return myMove;
	}
	 
	public Move getMove1(State gameState) {
		Move myMove;
		moveOrder++;
		myMove = new Move();
		myMove.setValues(1, 1);
		return myMove;
	}
	 
	public Move getMove2(State gameState) {
		Move myMove;
		if (gameState.InformOccupiedPosition(2, 2)) {
			strategyWay = 3;
			moveOrder++;
			myMove = new Move();
			myMove.setValues(3, 3);
		} else {
			if ((gameState.InformOccupiedPosition(2, 1)) || (gameState.InformOccupiedPosition(2, 3)) 
			   || (gameState.InformOccupiedPosition(3, 1)) ) {
				strategyWay = 2;
				moveOrder++;
				myMove = new Move();
				myMove.setValues(1, 3);
			} else {
				strategyWay = 1;
				moveOrder++;
				myMove = new Move();
				myMove.setValues(3, 1);
			};
		};
		return myMove;
	}
	 
	public Move getMove3(State gameState) {
		Move myMove = null;
		switch (strategyWay) {
		case 1: myMove = this.getMove3Way1(gameState);
		break;
		case 2: myMove = this.getMove3Way2(gameState);
		break;
		case 3: myMove = this.getMove3Way3(gameState);	
		};
		return myMove;
	}
	 
	public Move getMove3Way1(State gameState) {
		Move myMove;
		if (gameState.informEmptyPosition(2, 1)) {
			myMove = this.getBasicMove(gameState);
		} else {
			if ((gameState.informEmptyPosition(3, 2)) && (gameState.informEmptyPosition(3, 3)) ) {
				moveOrder++;
				myMove = new Move();
				myMove.setValues(3, 3);
			} else {
				moveOrder++;
				myMove = new Move();
				myMove.setValues(1, 3);
			};
		};
		return myMove;
	}
	 
	public Move getMove3Way2(State gameState) {
		Move myMove;
		if (gameState.informEmptyPosition(1, 2)) {
			myMove = this.getBasicMove(gameState);
		} else {
			if ((gameState.informEmptyPosition(2, 3)) && (gameState.informEmptyPosition(3, 3)) ) {
				moveOrder++;
				myMove = new Move();
				myMove.setValues(3, 3);
			} else {
				moveOrder++;
				myMove = new Move();
				myMove.setValues(3, 1);
			};
		};
		return myMove;
	}
	 
	public Move getMove3Way3(State gameState) {
		Move myMove;
		if (gameState.InformOccupiedPosition(3, 1)) {
			moveOrder++;
			myMove = new Move();
			myMove.setValues(1, 3);
		} else {
			if (gameState.InformOccupiedPosition(1, 3)) {
				moveOrder++;
				myMove = new Move();
				myMove.setValues(3, 1);
			} else {
				myMove = this.getBasicMove(gameState);
			};
		};
		return myMove;
	}
	 
}
 