package InterfaceParts;

import CommonClasses.Move;
import CommonClasses.Player;
import CommonInterfaces.InterfaceManagerProxy;
import InternalStructure.InternalManager;
import cip.InterfacePort;

public class PortManagerProxy extends InterfacePort implements InterfaceManagerProxy {
	
	protected InternalManager internalReference;
	protected Player player;

	public PortManagerProxy(String argId) {
		id = argId;
	}
	
	@Override
	public void initialize() {
		outbox = new PortManagerProxyOutbox();
	}
	
	public void setPlayer (Player aPlayer) {
		player = aPlayer;
	}
	
	public Player getPlayer () {
		return player;
	}

	public boolean isYourId (String anId) {
		return (anId.equals(id));
	}
	
	public void setInternalReference (InternalManager argB) {
		internalReference = argB;
	}

	@Override
	public void connect(String arg0) {
		internalReference.connect(id, arg0);
	}

	@Override
	public void disconnect(String arg0) {
		internalReference.disconnect(id, arg0);
	}

	@Override
	public void getConnectedPlayers() {
		internalReference.getConnectedPlayers(id);
	}

	@Override
	public void giveUp(String arg0) {
		internalReference.giveUp(id, arg0);
	}

	@Override
	public void makeMove(Move arg0) {
		internalReference.makeMove(id, arg0);
	}

	@Override
	public void sendMessage(String arg0) {
		internalReference.sendMessage(id, arg0);
	}

	@Override
	public void start(Player arg0) {
		internalReference.start(id, arg0);
	}

}
