package InterfaceParts;

import CommonClasses.CommunicationContainer;
import CommonClasses.State;
import CommonInterfaces.InterfaceProxyManager;
import InternalStructure.InternalServerProxy;
import cip.InterfacePort;

public class PortManager2 extends InterfacePort implements InterfaceProxyManager {

	protected InternalServerProxy internalReference;
	private TTTManagerProxy componentRoot;
	
	public PortManager2(String string) {
		id = string;
	}
	
	public void setInternalReference(InternalServerProxy internalObject) {
		internalReference = internalObject;
	}
	
	public void setComponentRoot(TTTManagerProxy root) {
		componentRoot = root;
	}
	
	@Override
	public void initialize() {
		outbox = new PortManager2Outbox();
	}

	@Override
	public void communicate(CommunicationContainer arg0) {
		internalReference.communicate(arg0);
	}

	@Override
	public boolean connect(String arg0) {
		return internalReference.connect(arg0);
	}

	@Override
	public void receiveMessage(String arg0) {
		internalReference.receiveMessage(arg0);
	}

	@Override
	public void updateState(State arg0) {
		internalReference.updateState(arg0);
	}

	@Override
	public void selfDestruct() {
		internalReference.disconnectNG();
		this.disconnect();
		outbox = null;
		internalReference.selfDestruct();
		this.setInternalReference(null);	
		componentRoot.selfDestruct();
	}

/*	@Override
	public String getOpponetId() {
		return internalReference.getOpponetId();
	}
*/	
}
