package InterfaceParts;

import CommonInterfaces.InterfaceProxyServer;
import CommonInterfaces.Throw;
import InternalStructure.InternalManagerProxy;
import br.ufsc.inf.leobr.cliente.Jogada;
import br.ufsc.inf.leobr.cliente.OuvidorProxy;
import cip.InterfacePort;

public class PortServer extends InterfacePort implements InterfaceProxyServer, OuvidorProxy {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected InternalManagerProxy internalReference;

	public PortServer(String string) {
		id = string;
	}
	
	public void setInternalReference(InternalManagerProxy internalObject) {
		internalReference = internalObject;
		((PortServerOutbox) outbox).connectToNetgames(this);
	}
	
	public void selfDestruct() {
//		this.disconnect();
		internalReference.selfDestruct();
		this.setInternalReference(null);		
//		((PortServerOutbox) outbox).disconnectNG();
		outbox = null;		
	}

	@Override
	public void initialize() {
		outbox = new PortServerOutbox();
		((PortServerOutbox) outbox).initialize();
	}

	@Override
	public void receive(Throw arg0) {
		internalReference.receive(arg0);		
	}

	@Override
	public void receiveMessage(String arg0) {
		internalReference.receiveMessage(arg0);
	}

	@Override
	public void start(int arg0) {
		internalReference.start(arg0);
	}

	@Override
	public void iniciarNovaPartida(Integer posicao) {
		this.start(posicao);
	}

	@Override
	public void receberMensagem(String msg) {
		this.receiveMessage(msg);
	}

	@Override
	public void receberJogada(Jogada jogada) {
		this.receive((Throw) jogada);
	}
	
	@Override
	public void finalizarPartidaComErro(String message) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void tratarConexaoPerdida() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void tratarPartidaNaoIniciada(String message) {
		// TODO Auto-generated method stub
		
	}

}
