package InternalStructure;

import CommonClasses.Move;
import CommonClasses.Player;
import CommonClasses.CommunicationContainer;
import CommonClasses.CommunicationKind;
import CommonInterfaces.InterfaceProxyServer;
import CommonInterfaces.Throw;
import InterfaceParts.PortManager2;
import InterfaceParts.PortManager2Outbox;
import InterfaceParts.PortServer;
import InterfaceParts.PortServerOutbox;

public class InternalManagerProxy implements InterfaceProxyServer {
	
	protected PortManager2 portManager;
	protected PortServer portServer;
	
	public void setPortManager (PortManager2 aPortManager) {
		portManager = aPortManager;
	}
	
	public void setPortServer (PortServer aPortServer) {
		portServer = aPortServer;
	}
	
	public void selfDestruct() {
		this.setPortManager(null);
		this.setPortServer(null);
	}

	@Override
	public void receive(Throw arg0) {
		PortManager2Outbox outbox = (PortManager2Outbox) portManager.getOutbox();
		if (arg0 instanceof Move) {
			outbox.makeMove((Move) arg0);
		} else {
			if (arg0 instanceof Player) {
				outbox.start((Player) arg0);
			} else {
				String content = ((CommunicationContainer) arg0).getContent();
				CommunicationKind kind = ((CommunicationContainer) arg0).getKind();
				if (kind == CommunicationKind.giveUpRequest) {
					outbox.giveUp(content);
				} else {
					if (kind == CommunicationKind.disconnectRequest) {
						outbox.disconnect(content);
					} else {
						if (kind == CommunicationKind.playerIdRequest) outbox.getConnectedPlayers();
					}
				}
			}
		}
		
	}

	@Override
	public void receiveMessage(String arg0) {
		PortManager2Outbox outbox = (PortManager2Outbox) portManager.getOutbox();
		outbox.sendMessage(arg0);		
	}

	@Override
	public void start(int arg0) {
		PortManager2Outbox managerOutbox = (PortManager2Outbox) portManager.getOutbox();
		PortServerOutbox serverOutbox = (PortServerOutbox) portServer.getOutbox();
		String playerId = serverOutbox.getOpponentId();
		managerOutbox.connect(playerId);
	}

}
