package InternalStructure;

import CommonClasses.CommunicationContainer;
import CommonClasses.State;
import CommonInterfaces.InterfaceProxyManager;
import InterfaceParts.PortServer;
import InterfaceParts.PortServerOutbox;

public class InternalServerProxy implements InterfaceProxyManager {
	
	protected PortServer portServer;
	
	public void setPortServer (PortServer aPortServer) {
		portServer = aPortServer;
	}

	@Override
	public void selfDestruct() {
		this.setPortServer(null);
	}

	@Override
	public void communicate(CommunicationContainer arg0) {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		outbox.send(arg0);
	}

	@Override
	public boolean connect(String arg0) {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		outbox.connect(arg0);
		return true;
	}

	@Override
	public void receiveMessage(String arg0) {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		outbox.sendMessage(arg0);
	}

	@Override
	public void updateState(State arg0) {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		outbox.send(arg0);
	}

	public void disconnectNG() {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		outbox.disconnect();		//		disconnectNG()
	}

/*	@Override
	public String getOpponetId() {
		PortServerOutbox outbox = (PortServerOutbox) portServer.getOutbox();
		return outbox.getOpponentId();
	}
*/
}
